﻿using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace Padsurface.App.UserControls
{
    public sealed partial class TimerUserControl : UserControl
    {
        #region Caption property

        public string Caption
        {
            get { return (string)GetValue(CaptionProperty); }
            set { SetValue(CaptionProperty, value); }
        }

        public static readonly DependencyProperty CaptionProperty =
            DependencyProperty.Register("Caption", typeof(string), typeof(TimerUserControl), new PropertyMetadata("Timer"));

        #endregion

        #region Time property

        public string Time
        {
            get { return (string)GetValue(TimeProperty); }
            set { SetValue(TimeProperty, value); }
        }

        public static readonly DependencyProperty TimeProperty =
            DependencyProperty.Register("Time", typeof(string), typeof(TimerUserControl), new PropertyMetadata("00:00:00"));

        #endregion

        public TimerUserControl()
        {
            this.InitializeComponent();
        }
    }
}
