﻿using System;
using System.Runtime.InteropServices;

namespace Padsurface.CoreAudio.MultiMediaStructures
{
    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 2)]
    public class WaveFormatEx : WaveFormat
    {
        /// <summary>
        /// Bits per sample for the FormatTag format type.
        /// If FormatTag is WAVE_FORMAT_PCM, then wBitsPerSample should be equal to 8 or 16.
        /// </summary>
        public UInt16 BitsPerSample;

        /// <summary>
        /// Size, in bytes, of extra format information appended to the end of the WAVEFORMATEX structure. 
        /// This information can be used by non-PCM formats to store extra attributes for the wFormatTag. 
        /// If no extra information is required by the wFormatTag, this member must be set to 0.
        /// </summary>
        public UInt16 ExtraSize;
    }
}
